/** 
 * SMARTS cognitive science programming project
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;
import java.awt.Color;

public class Heading {
    
  public static final String[]
    NAMES = {"N", "NE", "SE", "S", "SW", "NW"};
    
  public static final Color
    COLOR = Color.black;
    
  public static final int
    N_POSSIBLE_VALUES = 6;
    
  private UI ui;
  
  private int value;
    
  /**
  * This constructor just sets the UI and the value.
  */
  Heading(UI ui) {
    this.ui = ui;
    value = (int)(Math.random() * N_POSSIBLE_VALUES);
  } // constructor Heading

  // Access method

  public int getValue() {
      return value;
  } // method getValue()
  
  public void setValue(int v) {
      value = v;
  } // method setValue(int)
  
  public void add(int a) {
      value = add(value, a);
  } // method add(int)
  
  /**
  * Adds the two heading values.
  */
  public static int add(int h1, int h2) {
      return ((h1 + h2) % 6);
  } // method add(int, int)
  
  public static int abs(int rotation) {
      if (rotation <= 3)
	  return rotation;
      else
	  return (6 - rotation);
  } // method abs(int)
  
} // class Heading
