/** 
 * SALSA 2
 * July 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;
import java.util.Vector;

public class Param extends Vector {
    
  private static int
    // Types
    INTEGER = 0,
    CHOICE = 1,
    DOUBLE = 2,
  
    VALUE = 0,
    LABEL = 1,
    MIN = 2,
    MAX = 3,
    CHOICES = 2;
    
  private UI ui;
  
  private int type;

  Param(UI ui) {
      super();
      this.ui = ui;
  } // constructor Param(UI)
  
  Param(UI ui, int def, int min, int max, String label) {
      this(ui);
      init(def, min, max, label);
  }

  Param(UI ui, double def, double min, double max, String label) {
      this(ui);
      init(def, min, max, label);
  }
  
  Param(UI ui, int defIndex, String label, String[] choices) {
      this(ui);
      init(defIndex, label, choices);
  }

  // Access methods.
  
  public int get() {
      return ((Integer)(elementAt(VALUE))).intValue();
  }
  
  public String getLabel() {
      return (String)(elementAt(LABEL));
  }
  
  public String[] getChoices() {
      return (String[])(elementAt(CHOICES));
  }
  
  public boolean isInt() {
      return type < DOUBLE;
  }
  
  public boolean isDouble() {
      return type == DOUBLE;
  }
  
  public boolean hasChoice() {
      return type == CHOICE;
  }
  
  // Setter methods.
  
  public void set(int value) {
      setElementAt(new Integer(value), VALUE);
  }
  
  private void init(int def, int min, int max, String label) {
      Integer
          defO = new Integer(def),
	  minO = new Integer(min),
	  maxO = new Integer(max);

      addElement(defO);
      addElement(label);
      addElement(minO);
      addElement(maxO);
      
      type = INTEGER;
  }
  
  private void init(double def, double min, double max, String label) {
      Double
        defO = new Double(def),
	minO = new Double(min),
	maxO = new Double(max);

      addElement(defO);
      addElement(label);
      addElement(minO);
      addElement(maxO);
      
      type = DOUBLE;
  }
  
  private void init(int defIndex, String label, String[] choices) {
      Integer
        defO = new Integer(defIndex);
      
      addElement(defO);
      addElement(label);
      addElement(choices);
      
      type = CHOICE;
  }
  
} // class Param
